<?php
class StudipContentCopyPlugin extends StudIPPlugin implements SystemPlugin
{

	public static $config = array();

	function __construct() {
		parent::__construct();
        $this->me = get_class($this);
		$this->restoreConfig();
        if (Navigation::hasItem('/admin/course')) {
            $nav = new Navigation($this->getDisplaytitle(), PluginEngine::getURL("$this->me/copy"));
            Navigation::addItem('/admin/course/'.$this->me, $nav);
        }
	}

	function restoreConfig(){
		$config = DBManager::get()
				->query("SELECT comment FROM config WHERE field = 'CONFIG_" . $this->getPluginName() . "' AND is_default=1")
				->fetchColumn();
		self::$config = unserialize($config);
		return self::$config != false;
	}

	function storeConfig(){
		$config = serialize(self::$config);
		$field = "CONFIG_" . $this->getPluginName();
		$st = DBManager::get()
		->prepare("REPLACE INTO config (config_id, field, value, is_default, type, range, chdate, comment)
			VALUES (?,?,'do not edit',1,'string','global',UNIX_TIMESTAMP(),?)");
		return $st->execute(array(md5($field), $field, $config));
	}

	function getDisplaytitle() {
		return _("Inhalte importieren");
	}

	/**
	* This method dispatches and displays all actions. It uses the template
	* method design pattern, so you may want to implement the methods #route
	* and/or #display to adapt to your needs.
	*
	* @param  string  the part of the dispatch path, that were not consumed yet
	*
	* @return void
	*/
    function perform($unconsumed_path) {
        if(!$unconsumed_path){
            header("Location: " . PluginEngine::getUrl($this,array(),'copy'), 302);
            return false;
        }
        $trails_root = $this->getPluginPath();
        $dispatcher = new Trails_Dispatcher($trails_root, null, 'copy');
        $dispatcher->current_plugin = $this;
        $dispatcher->dispatch($unconsumed_path);
    }

}
