<?php
require "application.php";

require_once "lib/datei.inc.php";
require_once "lib/classes/Seminar.class.php";
require_once "lib/classes/StudipScmEntry.class.php";
require_once "lib/classes/StudipDocumentTree.class.php";

class CopyController extends ApplicationController
{

	function before_filter(&$action, &$args) {
		parent::before_filter($action, $args);

		$_REQUEST['list'] = !$args[0];
		if($_REQUEST['list'] === true){
			$GLOBALS['view_mode'] = 'sem';
			$GLOBALS['links_admin_data'] =& $_SESSION['links_admin_data'];
			include 'lib/admin_search.inc.php';
			$GLOBALS['i_page'] = 'adminarea_start.php';
		}
		$this->is_admin = $GLOBALS['perm']->have_perm('admin');
		//$this->destination_id =& $_SESSION[$this->plugin->getPluginname()]['destination_id'];
		if(!($this->destination_id = $args[0])) $this->destination_id = $_SESSION['SessionSeminar'];
		if(!$this->destination_id && !$GLOBALS['list']) throw new Exception(_("Keine Veranstaltung gewhlt!"));
		$this->source_id =& $_SESSION[$this->plugin->getPluginname()]['source_id'];
		if ($this->source_id == $this->destination_id) {
			$this->source_id = null;
		}
	   if(!$GLOBALS['perm']->have_studip_perm('tutor',$this->destination_id) || ($this->source_id && !$GLOBALS['perm']->have_studip_perm('tutor', $this->source_id))) {
            throw new Studip_AccessDeniedException(_("Keine Berechtigung."));
        }
	}

	function index_action(){
		Navigation::activateItem('/admin/course/' . $this->plugin->me);
		if(Request::submitted('do_search_destination') || Request::submitted('do_search_source')){
			$search_what = Request::submitted('do_search_destination') ? Request::quoted('search_destination') : Request::quoted('search_source');
			$result = search_range($search_what);
		}
		if(!$this->is_admin){
			$result = search_range();
		}
		if(is_array($result)){
			$result = array_filter($result, create_function('$r', 'return $r["type"] == "sem";'));
			if(count($result)){
				$this->result = $result;
				if($this->is_admin){
					$this->flash_now('success', sprintf(_("Ihre Sucher ergab %s Treffer."), count($result)));
				}
				$this->show_destination_result = !$this->is_admin || Request::submitted('do_search_destination');
				$this->show_source_result = !$this->is_admin || Request::submitted('do_search_source');
			}
		} else if ($this->is_admin && $result === false){
			$this->flash_now('info', _("Ihre Suche ergab keine Treffer."));
		}

		if(Request::submitted('do_choose_destination')){
			if(Request::option('search_destination_result') != $this->source_id ){
				$this->destination_id = Request::option('search_destination_result');
			} else {
				$this->flash_now('info', _("Quelle und Ziel mssen verschieden sein!"));
			}
		}
		if(Request::submitted('do_choose_source')){
			if(Request::option('search_source_result') != $this->destination_id){
				$this->source_id = Request::option('search_source_result');
			} else {
				$this->flash_now('info', _("Quelle und Ziel mssen verschieden sein!"));
			}
		}
		$semester = SemesterData::GetInstance();
		if($_SESSION['SessionSeminar'] != '' && is_null($this->destination_id)){
		 	$this->destination_id = $_SESSION['SessionSeminar'];
		}
		if($this->destination_id){
			if(!$GLOBALS['perm']->have_studip_perm('tutor', $this->destination_id)){
				throw new Studip_AccessDeniedException(_("Keine Berechtigung."));
			}
			$this->destination = Seminar::getInstance($this->destination_id);
			$seminar_semester = $semester->getSemesterDataByDate($this->destination->getSemesterStartTime());
			$this->destination_name = $this->destination->getName() . ' ('.$seminar_semester['name'].')';
		}
		if($this->source_id){
			if(!$GLOBALS['perm']->have_studip_perm('tutor', $this->source_id)){
				throw new Studip_AccessDeniedException(_("Keine Berechtigung."));
			}
			$this->source = Seminar::getInstance($this->source_id);
			$seminar_semester = $semester->getSemesterDataByDate($this->source->getSemesterStartTime());
			$this->source_name = $this->source->getName() . ' ('.$seminar_semester['name'].')';
		}
		if($this->source && $this->destination){
			$modules = new Modules();
			$source_modules = $modules->getLocalModules($this->source_id,'sem',$this->source->modules,$this->source->status);
			if($source_modules['scm']){
				$this->scm_content = StudipScmEntry::GetSCMEntriesForRange($this->source_id);
			}
			if($source_modules['documents']){
				$source_document_tree = TreeAbstract::GetInstance("StudipDocumentTree", array('range_id' => $this->source_id));
				foreach((array)$source_document_tree->getKids('root') as $virtual_id){
					foreach($source_document_tree->getKids($virtual_id) as $folder_id){
						$this->documents_content[$folder_id] = $source_document_tree->getValue($folder_id, 'name');
					}
				}
			}
			if(Request::submitted('do_copy')){
				$destination_modules = $modules->getLocalModules($this->destination_id,'sem',$this->destination->modules,$this->destination->status);
				$scms = Request::getArray('scm_to_copy');
				foreach($scms as $old_scm_id => $action){
					if($action == true && isset($this->scm_content[$old_scm_id])){
						$scm = new StudipScmEntry();
						$scm->setValue('tab_name', $this->scm_content[$old_scm_id]['tab_name']);
						$scm->setValue('content', $this->scm_content[$old_scm_id]['content']);
						$scm->setValue('user_id', $GLOBALS['user']->id);
						$scm->setValue('range_id', $this->destination_id);
						if ($scm->store() !== false) {
							$copied[] = $scm->getValue('tab_name');
						}
					}
				}
				if(is_array($copied)){
					$this->flash_now('success', _("Folgende Kapitel der freien Informationsseite wurden kopiert:") . '<b>' . htmlready(implode(', ', $copied)). '</b>');
					if(!$destination_modules['scm'] && $modules->writeStatus('scm', $this->destination_id, true, 'sem')){
						$this->flash_now('success', _("Die freie Informationsseite wurde in der Zielveranstaltung aktiviert."));
					}
				}

				$folders = Request::getArray('folder_copy_action');
				$dont_change_name_folders = Request::getArray('folder_copy_name');

				foreach($folders as $old_folder_id => $action){
					if($action && isset($this->documents_content[$old_folder_id])){
						if($action == 'top_level'){
							$new_range_id = md5($this->destination_id . 'top_folder');
						}
						if($action == 'general_folder'){
							$new_range_id = DBManager::get()
											->query("SELECT folder_id FROM folder WHERE range_id='{$this->destination_id}'")
											->fetchColumn();
						}
						if($new_range_id){
							$complete_folder = $source_document_tree->getKidsKids($old_folder_id);
							$complete_folder[] = $old_folder_id;
							$seed = md5(uniqid('blaofuasof',1));
							$change_name_to = !isset($dont_change_name_folders[$old_folder_id]) ? _("Kopie von") . ' ' . $this->documents_content[$old_folder_id] : '';
							$folder_count = $this->copy_folder($old_folder_id, $new_range_id, $seed, $source_document_tree, $change_name_to);
							if($folder_count){
								$complete_new_folder = array_map(create_function('$a','return md5($a."'.$seed.'");'), $complete_folder);
								$query = "SELECT dokument_id, range_id FROM dokumente
										INNER JOIN auth_user_md5 ON auth_user_md5.user_id=dokumente.user_id AND perms NOT IN ('user','autor')
										WHERE range_id IN('".join("','", $complete_folder)."')";
								$documents = DBManager::get()->query($query)->fetchAll(PDO::FETCH_ASSOC);
								$doc_count = 0;
								foreach($documents as $one_doc){
									$doc_count += copy_doc($one_doc['dokument_id'], md5($one_doc['range_id'].$seed), $this->destination_id);
								}
								/*if($doc_count){
									$query = sprintf("UPDATE dokumente SET user_id='%s'
													WHERE range_id IN ('%s')",
									$GLOBALS['user']->id,
									join("','", $complete_new_folder));
									DBManager::get()->query($query);
								}*/
								$at_least_one_thing_copied = true;
								$this->flash_now('success', sprintf(_("Der Ordner <b>%s</b> wurde mit %s Dokumenten kopiert."), htmlready($this->documents_content[$old_folder_id]), $doc_count));
							} else {
								$this->flash_now('error', sprintf(_("Der Ordner <b>%s</b> konnte nicht kopiert werden."), htmlready($this->documents_content[$old_folder_id])));
							}
						} else {
							$this->flash_now('error', sprintf(_("Der Ordner <b>%s</b> konnte nicht kopiert werden, da im Ziel kein allgemeiner Dateiordner existiert."), htmlready($this->documents_content[$old_folder_id])));
						}
					}
				}
				if($at_least_one_thing_copied){
					if(!$destination_modules['documents'] && $modules->writeStatus('documents', $this->destination_id, true, 'sem')){
						$this->flash_now('success', _("Der Dateibereich wurde in der Zielveranstaltung aktiviert."));
					}
				}
			}
		}

	}

	function copy_folder($folder_id, $new_range, $seed, $document_tree, $change_name_to = ''){
		$db = DBManager::get();
		$rs = $db->query("SELECT MD5(CONCAT(folder_id,'$seed')), '$new_range', user_id, name,
					description, mkdate, " .time(). " as chdate,7 FROM folder WHERE folder_id='$folder_id'");
		if ($record = $rs->fetch()){
			$record[3] = $change_name_to != '' ? mysql_escape_string($change_name_to) : mysql_escape_string($record[3]);
			$record[4] = mysql_escape_string($record[4]);
			$ok = $db->exec("INSERT INTO folder (folder_id, range_id, user_id, name,
						description, mkdate, chdate,permission) VALUES ( '{$record[0]}','{$record[1]}',
						'{$record[2]}','{$record[3]}','{$record[4]}',{$record[5]},
						{$record[6]},{$record[7]})");
			if (!$ok){
				return false;
			} else {
				$count = 1;
				$folder = $document_tree->getKidsKids($folder_id);
				if (is_array($folder)){
					foreach($folder as $id){
						$rs = $db->query("SELECT MD5(CONCAT(folder_id,'$seed')), MD5(CONCAT(range_id,'$seed')), user_id, name,
									description, mkdate, " .time(). " as chdate,7 FROM folder WHERE folder_id='$id'");
						if ($record = $rs->fetch()){
							$record[3] = mysql_escape_string($record[3]);
							$record[4] = mysql_escape_string($record[4]);
							$ok = $db->exec("INSERT INTO folder (folder_id, range_id, user_id,
										name, description, mkdate, chdate, permission) VALUES (
										'{$record[0]}','{$record[1]}','{$record[2]}',
										'{$record[3]}','{$record[4]}',{$record[5]},
										{$record[6]},{$record[7]})");
							$count += $ok;
						}
					}
				}
				return $count;
			}
		}
	}
}